package com.sun.perf.web;

import com.sun.perf.ejb.*;
import com.sun.perf.util.*;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Properties;
import javax.sql.*;

import javax.ejb.EJB;
import javax.jms.*;
import javax.naming.*;
import javax.rmi.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.transaction.*;

public class PingServlet extends HttpServlet {

    QueueConnectionFactory qFactory;
    Queue q;
    int hitCount;

    public void init(ServletConfig sc) throws ServletException {
        super.init(sc);
	try {
            InitialContext ic = new InitialContext();
            qFactory = (QueueConnectionFactory)
                ic.lookup("java:comp/env/jms/PingQueueConnectionFactory");
            q = (Queue) ic.lookup("java:comp/env/jms/PingQueue");
	} catch (Exception e) {
	    throw new ServletException(e);
	}
    }

    public void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
	resp.setContentType("text/html");
	QueueConnection qc = null;
	QueueSession qs = null;
        try {
	    com.sun.perf.ejb.PingMDB.semaphore.acquire();
            qc = qFactory.createQueueConnection();
	    qs = qc.createQueueSession(true, Session.AUTO_ACKNOWLEDGE);
            QueueSender sender = qs.createSender(q);
	    ObjectMessage message = qs.createObjectMessage();
	    message.setObject(new MyObject());
	    sender.send(message);
	} catch (Exception e) {
	    throw new ServletException(e);
	} finally {
	    try { if (qc != null) qc.close(); } catch (Exception e) {}
	    try { if (qs != null) qs.close(); } catch (Exception e) {}
	}
	ServletOutputStream out = resp.getOutputStream();
	out.println("<html><head><title>Ping Local Servlet</title></head>"
		+ "<body><HR><BR><FONT size=\"+2\" color=\"#000066\">Ping Servlet<BR></FONT><FONT size=\"+1\" color=\"#000066\">Init time : "
		+ "<BR><BR></FONT>  <B>Hit Count: "
		+ hitCount++
		+ "</B></body></html>");
	out.close();
    }
}
